--All quits
TAG = ...
TAG.UI = ...
TAG.UI.Context = UI.CreateContext("TAG")
print( "/TagHelp for help!")

local txt_playerIT = UI.CreateFrame("Text", "", TAG.UI.Context)
txt_playerIT:SetPoint("TOPCENTER", UIParent, "TOPCENTER", 0, 300)
txt_playerIT:SetFontSize(40)

local playerIT = {name = "x"}
local previousIT = {name = "x"}

local isPlaying = true
local targetPlaying = false

local players = {}

function Tag()
	isPlaying = true
	if playerIT.name == "x" then
		Command.Message.Broadcast("yell", nil, "TAG.PlayerJoin", Inspect.Unit.Detail("player").name)
	end
	
	if Inspect.Unit.Detail("player.target") == nil or Inspect.Unit.Detail("player.target").name == Inspect.Unit.Detail("player").name then 
		return end
	if playerIT.name == Inspect.Unit.Detail("player").name then
		if not GetDistance() then return end
		Command.Message.Broadcast("tell", Inspect.Unit.Detail("player.target").name, "TAG.Tagged", "")
	end
end

function GetDistance()
	local pPosX, pPosY, pPosZ
	local tPosX, tPosY, tPosZ
	
	pPosX = Inspect.Unit.Detail("player").coordX
	pPosY = Inspect.Unit.Detail("player").coordY
	pPosZ = Inspect.Unit.Detail("player").coordZ
	
	tPosX = Inspect.Unit.Detail("player.target").coordX
	tPosY = Inspect.Unit.Detail("player.target").coordY
	tPosZ = Inspect.Unit.Detail("player.target").coordZ
	
	local maxDistance = 4
	if math.abs(pPosX - tPosX) > maxDistance then return false end
	if math.abs(pPosY - tPosY) > maxDistance then return false end
	if math.abs(pPosZ - tPosZ) > maxDistance then return false end
	
	return true
end

function BroadcastReceive(handle, from, type, channel, identifier, data)
	local playerName = Inspect.Unit.Detail("player").name
	if isPlaying then
		--Tag Receive
		if identifier == "TAG.Tagged" then
			Command.Message.Broadcast("yell", nil, "TAG.PlayerTagged", from)
			
		--New Player Tagged
		elseif identifier == "TAG.PlayerTagged" then
			if isPlaying then print(data .. " tagged " .. from .. "!") end
				previousIT.name = playerIT.name
				playerIT.name = from
			if isPlaying then txt_playerIT:SetText(playerIT.name .. " is IT!") end
			
		--Join Receive
		elseif identifier == "TAG.PlayerJoin" then
			if from ~= playerName then
			Command.Message.Broadcast("tell", from, "TAG.GiveInfo", playerIT.name)
			--players[table.getn(players)] = from
			end
			
		--Information Receive
		elseif identifier == "TAG.GiveInfo" then
			--No one is it
			if data == "x" then
				playerIT.name = playerName
			else
				playerIT.name = data
				txt_playerIT:SetText(playerIT.name .. " is IT!")
			end
			
		--ITQuits Receive
		elseif identifier == "TAG.ITQuit" then
			if isPlaying then print(from .. " quit playing.") end
			if data == "x" or data == playerIT.name then 
				playerIT.name = "x"
				previousIT.name = "x"
				txt_playerIT:SetText("")
			else 
				playerIT.name = data
				if isPlaying then 
					print(data .. " is now IT!")
					txt_playerIT:SetText(playerIT.name .. " is IT!")
				end
			end
		end
	end
end

function NoTag()
	if isPlaying then
		if playerIT.name == Inspect.Unit.Detail("player").name then
			Command.Message.Broadcast("channel", "tag", "TAG.ITQuit", previousIT.name)
		end
		txt_playerIT:SetText("")
		isPlaying = false
		playerIT.name = "x"
		previousIT.name = "x"
	end
end

function TagHelp()
print("Target a player and type /TAG")
print("Type /NOTAG to quit playing.")
print("Join the tag channel! /Join TAG")
end


Command.Event.Attach(Event.Message.Receive, BroadcastReceive, "BroadcastReceived")
Command.Message.Accept(nil, "TAG.PlayerTagged")
Command.Message.Accept(nil, "TAG.PlayerJoin")
Command.Message.Accept(nil, "TAG.GiveInfo")
Command.Message.Accept(nil, "TAG.ITQuit")
Command.Message.Accept(nil, "TAG.Tagged")

table.insert (Command.Slash.Register("Tag"), {Tag, "TAG", "Tag"})
table.insert (Command.Slash.Register("NoTag"), {NoTag, "TAG", "NoTag"})
table.insert (Command.Slash.Register("TagHelp"), {TagHelp, "TAG", "TagHelp"})
table.insert (Event.Unit.Detail.Zone, {NoTag, "TAG", "NoTag"})

--------------------------------
-- UI --------------------------
--------------------------------

--local ui_
